<?php

namespace App\Http\Controllers;

use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class InicioController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {

        $idUsuario = Auth::user()->id;


        $archivosEmpleado =  User::with(['datosEmpleado.archivosNominas' => function($q){
            return $q->where('archivos_nominas.activo',1)->where('archivos_nominas.eliminado',0)->orderBy('numero_nomina','DESC')->take(3)->get();
        }])->where('id',$idUsuario)->first();
        // dd( $archivosEmpleado );
        $usuarioEmpleaodo = User::with(['datosEmpleado.archivosNominas' => function($q){
            return  $q->where('archivos_nominas.activo',1)->where('archivos_nominas.eliminado',0)->orderBy('numero_nomina','DESC')->first();
        }])->where('id',$idUsuario)->first();

        return view('inicio',[
            'nombreEmpleado' => $usuarioEmpleaodo['datosEmpleado']?->nombre_completo,
            'nombreArchivo' => isset($usuarioEmpleaodo['datosEmpleado']['archivosNominas'][0]) ? $usuarioEmpleaodo['datosEmpleado']['archivosNominas'][0]->nombre_archivo : 'No contiene archivos',
            'fechaArchivo' => isset($usuarioEmpleaodo['datosEmpleado']['archivosNominas'][0]) ? $usuarioEmpleaodo['datosEmpleado']['archivosNominas'][0]->fecha_registro : 'Aun no tiene fecha de actualizacion',
            'archivosEmpleado' => isset($archivosEmpleado) ? $archivosEmpleado : 'Aun no tiene fecha de actualizacion'
        ]);
    }
}
