<!DOCTYPE html>
<html dir="ltr">
  <head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <!-- Tell the browser to be responsive to screen width -->
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>Shades - Login</title>
    <link rel="canonical" href="https://www.wrappixel.com/templates/ampleadmin/" />
    <!-- Favicon icon -->
    <link rel="icon" type="image/png" sizes="16x16" href="../../assets/images/logos/logo2.png" />
    <!-- Custom CSS -->
    <link href="../../dist/css/style.min.css" rel="stylesheet" />
  </head>

  <body>
    <div class="main-wrapper">
      <div class="auth-wrapper d-flex no-block justify-content-center align-items-center" style="no-repeat center center; background-size: cover;">
        <div class="auth-box p-4 bg-white rounded">
          <div id="loginform">
            <div class="logo">
              {{-- <h3 class="box-title mb-3">Sign In</h3> --}}
              <div class="text-center">
                <img src="../../assets/images/logos/logo2.png" alt="homepage" class="dark-logo" />
              </div>
              @if (\Session::has('message'))
                    <div class="alert alert-dismissible fade show {{(Session::get('message')['type'] == 'success') ? "alert-success" : "alert-danger"}} fadeInUp animated" role="alert">
                        <strong>{{ Session::get('message')['title'] }}</strong> {{Session::get('message')['text']}}
                        {{-- <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                            <span aria-hidden="true">X</span>
                        </button> --}}
                    </div>
                @endif
            </div>
            <!-- Form -->
            <div class="row">
              <div class="col-12">
                <form class="form-horizontal mt-3 form-material" id="loginform" method="POST" action="{{ route('login') }}">
                    @csrf
                  <div class="form-group mb-3">
                    <div class="">
                      <input class="form-control @error('name') is-invalid @enderror" id="name"  name="name" value="{{ old('name') }}"  type="text" placeholder="Usuario" required autocomplete="name"/>

                      @error('name')
                      <span class="invalid-feedback" role="alert">
                          <strong>{{ $message }}</strong>
                      </span>
                  @enderror
                    </div>
                  </div>
                  <div class="form-group mb-4">
                    <div class="">
                      <input class="form-control @error('password') is-invalid @enderror" id="password" name="password" type="password" placeholder="Contraseña" required autocomplete="current-password" />
                      @error('password')
                      <span class="invalid-feedback" role="alert">
                          <strong>{{ $message }}</strong>
                      </span>
                  @enderror
                    </div>
                  </div>

                  <div class="form-group text-center mt-4 mb-3">
                    <div class="col-xs-12">
                      <button class="btn btn-info d-block w-100 waves-effect waves-light" type="submit">Ingresar</button>
                    </div>
                  </div>
                  <div class="row">

                  </div>

                </form>
              </div>
            </div>
          </div>

        </div>
      </div>

    </div>
    <script src="../../assets/libs/jquery/dist/jquery.min.js"></script>
    <script src="../../assets/libs/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script>
      $(".preloader").fadeOut();
      $("#to-recover").on("click", function () {
        $("#loginform").slideUp();
        $("#recoverform").fadeIn();
      });
    </script>
  </body>
</html>
