/*
 * bootstrap-table - v1.12.2 - 2018-11-29
 * https://github.com/wenzhixin/bootstrap-table
 * Copyright (c) 2018 zhixin wen
 * Licensed MIT License
 */
!(function (t) {
  "use strict";
  var o = t.fn.bootstrapTable.utils.sprintf,
    e = {
      json: "JSON",
      xml: "XML",
      png: "PNG",
      csv: "CSV",
      txt: "TXT",
      sql: "SQL",
      doc: "MS-Word",
      excel: "MS-Excel",
      xlsx: "MS-Excel (OpenXML)",
      powerpoint: "MS-Powerpoint",
      pdf: "PDF",
    };
  t.extend(t.fn.bootstrapTable.defaults, {
    showExport: !1,
    exportDataType: "basic",
    exportTypes: ["json", "xml", "csv", "txt", "sql", "excel"],
    exportOptions: {},
  }),
    t.extend(t.fn.bootstrapTable.defaults.icons, {
      export: "glyphicon-export icon-share",
    }),
    t.extend(t.fn.bootstrapTable.locales, {
      formatExport: function () {
        return "Export data";
      },
    }),
    t.extend(t.fn.bootstrapTable.defaults, t.fn.bootstrapTable.locales);
  var n = t.fn.bootstrapTable.Constructor,
    i = n.prototype.initToolbar;
  n.prototype.initToolbar = function () {
    if (
      ((this.showToolbar = this.showToolbar || this.options.showExport),
      i.apply(this, Array.prototype.slice.apply(arguments)),
      this.options.showExport)
    ) {
      var n = this,
        s = this.$toolbar.find(">.btn-group"),
        a = s.find("div.export");
      if (!a.length) {
        var p = (a = t(
            [
              '<div class="export btn-group">',
              '<button class="btn' +
                o(" btn-%s", this.options.buttonsClass) +
                o(" btn-%s", this.options.iconSize) +
                ' dropdown-toggle" aria-label="export type" title="' +
                this.options.formatExport() +
                '" data-bs-toggle="dropdown" type="button">',
              o(
                '<i class="%s %s"></i> ',
                this.options.iconsPrefix,
                this.options.icons.export
              ),
              '<span class="caret"></span>',
              "</button>",
              '<ul class="dropdown-menu" role="menu">',
              "</ul>",
              "</div>",
            ].join("")
          ).appendTo(s)).find(".dropdown-menu"),
          r = this.options.exportTypes;
        if ("string" == typeof this.options.exportTypes) {
          var l = this.options.exportTypes
            .slice(1, -1)
            .replace(/ /g, "")
            .split(",");
          (r = []),
            t.each(l, function (t, o) {
              r.push(o.slice(1, -1));
            });
        }
        t.each(r, function (t, o) {
          e.hasOwnProperty(o) &&
            p.append(
              [
                '<li role="menuitem" data-type="' + o + '">',
                '<a href="javascript:void(0)" class="dropdown-item py-0">',
                e[o],
                "</a>",
                "</li>",
              ].join("")
            );
        }),
          p.find("li").click(function () {
            var o = t(this).data("type"),
              e = function () {
                if (n.options.exportFooter) {
                  var e = n.getData(),
                    i = n.$tableFooter.find("tr").first(),
                    s = {},
                    a = [];
                  t.each(i.children(), function (o, e) {
                    var i = t(e).children(".th-inner").first().html();
                    (s[n.columns[o].field] = "&nbsp;" == i ? null : i),
                      a.push(i);
                  }),
                    n.append(s);
                  var p = n.$body.children().last();
                  t.each(p.children(), function (o, e) {
                    t(e).html(a[o]);
                  });
                }
                n.$el.tableExport(
                  t.extend({}, n.options.exportOptions, { type: o, escape: !1 })
                ),
                  n.options.exportFooter && n.load(e);
              },
              i = n.header.stateField;
            if ("all" === n.options.exportDataType && n.options.pagination)
              n.$el.one(
                "server" === n.options.sidePagination
                  ? "post-body.bs.table"
                  : "page-change.bs.table",
                function () {
                  i && n.hideColumn(i), e(), n.togglePagination();
                }
              ),
                n.togglePagination();
            else if ("selected" === n.options.exportDataType) {
              var s = n.getData(),
                a = n.getSelections();
              if (!a.length) return;
              if ("server" === n.options.sidePagination) {
                var p = { total: n.options.totalRows };
                (p[n.options.dataField] = s), (s = p);
                var r = { total: a.length };
                (r[n.options.dataField] = a), (a = r);
              }
              n.load(a), i && n.hideColumn(i), e(), n.load(s);
            } else i && n.hideColumn(i), e();
            i && n.showColumn(i);
          });
      }
    }
  };
})(jQuery);
